<template lang="html">
  <v-card>
    <v-card-title>Proposals</v-card-title>

    <v-card-text>
      <v-simple-table>
        <template v-slot:default>
          <thead>
            <tr>
              <th class="text-left">
                Details
              </th>
              <th class="text-left">
                Actions
              </th>
            </tr>


          </thead>
          <tbody>
            <item
              v-for="proposal in proposals"
              :key="proposal.proposalId"
              :details="proposal"
            />
          </tbody>
        </template>
      </v-simple-table>
    </v-card-text>
  </v-card>
</template>

<script>
import Item from "./proposal/Item";
import { getProposalEvents, findProposal, hashProposal } from "@/helpers/proposal";

export default {
  components: {
    Item
  },
  data() {
    return {
      proposals: []
    }
  },
  watch: {
    provider(value) {
      if (value) {
        this.providerAvailable();
      }
    }
  },
  computed: {
    provider() {
      return this.$store.state.provider;
    }
  },
  methods: {
    async providerAvailable() {
      this.proposals = await this.getProposals();
    },
    async getProposals() {
      const proposalEvents = await getProposalEvents();
      const proposals = [];

      for (const proposalEvent of proposalEvents) {
        const proposal = await findProposal(proposalEvent.args.proposalId);
        proposal.hash = await hashProposal(proposal);
        proposals.push(proposal);
      }

      return proposals.reverse();
    }
  }
}
</script>
